apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: (unknown)
  creationTimestamp: null
  name: outlierdetectionpolicies.networking.gke.io
spec:
  group: networking.gke.io
  names:
    kind: OutlierDetectionPolicy
    listKind: OutlierDetectionPolicyList
    plural: outlierdetectionpolicies
    singular: outlierdetectionpolicy
  scope: Namespaced
  versions:
  - name: v1alpha1
    schema:
      openAPIV3Schema:
        description: OutlierDetectionPolicy provides a way to apply LoadBalancer policy
          configuration with the GKE implementation of the Gateway API.
        properties:
          apiVersion:
            description: 'APIVersion defines the versioned schema of this representation
              of an object. Servers should convert recognized schemas to the latest
              internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources'
            type: string
          kind:
            description: 'Kind is a string value representing the REST resource this
              object represents. Servers may infer this from the endpoint the client
              submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds'
            type: string
          metadata:
            type: object
          spec:
            description: Spec defines the desired state of OutlierDetectionPolicy.
            properties:
              default:
                description: Default defines default policy configuration for the
                  targeted resource.
                properties:
                  baseEjectionTime:
                    default:
                      nanos: 0
                      seconds: 30
                    description: The base time that a host is ejected for. The real
                      ejection time is equal to the base ejection time multiplied
                      by the number of times the host has been ejected. Defaults to
                      30000ms or 30s.
                    properties:
                      nanos:
                        description: Span of time that's a fraction of a second at
                          nanosecond resolution. Durations less than one second are
                          represented with a 0 seconds field and a positive nanos
                          field. Must be from 0 to 999,999,999 inclusive.
                        format: int64
                        maximum: 999999999
                        minimum: 0
                        type: integer
                      seconds:
                        description: 'Span of time at a resolution of a second. Must
                          be from 0 to 315,576,000,000 inclusive. Note: these bounds
                          are computed from: 60 sec/min * 60 min/hr * 24 hr/day *
                          365.25 days/year * 10000 years'
                        format: int64
                        maximum: 315576000000
                        minimum: 0
                        type: integer
                    type: object
                  consecutiveErrors:
                    default: 5
                    description: Number of errors before a host is ejected from the
                      connection pool. When the backend host is accessed over HTTP,
                      a 5xx return code qualifies as an error. Defaults to 5.
                    format: int64
                    minimum: 0
                    type: integer
                  consecutiveGatewayFailure:
                    default: 3
                    description: The number of consecutive gateway failures (502,
                      503, 504 status or connection errors that are mapped to one
                      of those status codes) before a consecutive gateway failure
                      ejection occurs. Defaults to 3.
                    format: int64
                    minimum: 0
                    type: integer
                  enforcingConsecutiveErrors:
                    default: 0
                    description: The percentage chance that a host will be actually
                      ejected when an outlier status is detected through consecutive
                      5xx. This setting can be used to disable ejection or to ramp
                      it up slowly. Defaults to 0.
                    format: int64
                    maximum: 100
                    minimum: 0
                    type: integer
                  enforcingConsecutiveGatewayFailure:
                    default: 100
                    description: The percentage chance that a host will be actually
                      ejected when an outlier status is detected through consecutive
                      gateway failures. This setting can be used to disable ejection
                      or to ramp it up slowly. Defaults to 100.
                    format: int64
                    maximum: 100
                    minimum: 0
                    type: integer
                  enforcingSuccessRate:
                    default: 100
                    description: The percentage chance that a host will be actually
                      ejected when an outlier status is detected through success rate
                      statistics. This setting can be used to disable ejection or
                      to ramp it up slowly. Defaults to 100.
                    format: int64
                    maximum: 100
                    minimum: 0
                    type: integer
                  interval:
                    default:
                      nanos: 0
                      seconds: 1
                    description: Time interval between ejection analysis sweeps. This
                      can result in both new ejections as well as hosts being returned
                      to service. Defaults to 1 second.
                    properties:
                      nanos:
                        description: Span of time that's a fraction of a second at
                          nanosecond resolution. Durations less than one second are
                          represented with a 0 seconds field and a positive nanos
                          field. Must be from 0 to 999,999,999 inclusive.
                        format: int64
                        maximum: 999999999
                        minimum: 0
                        type: integer
                      seconds:
                        description: 'Span of time at a resolution of a second. Must
                          be from 0 to 315,576,000,000 inclusive. Note: these bounds
                          are computed from: 60 sec/min * 60 min/hr * 24 hr/day *
                          365.25 days/year * 10000 years'
                        format: int64
                        maximum: 315576000000
                        minimum: 0
                        type: integer
                    type: object
                  maxEjectionPercent:
                    default: 50
                    description: Maximum percentage of hosts in the load balancing
                      pool for the backend service that can be ejected. Defaults to
                      50%.
                    format: int64
                    maximum: 100
                    minimum: 0
                    type: integer
                  successRateMinimumHosts:
                    default: 5
                    description: The number of hosts in a cluster that must have enough
                      request volume to detect success rate outliers. If the number
                      of hosts is less than this setting, outlier detection via success
                      rate statistics is not performed for any host in the cluster.
                      Defaults to 5.
                    format: int64
                    minimum: 0
                    type: integer
                  successRateRequestVolume:
                    default: 100
                    description: The minimum number of total requests that must be
                      collected in one interval (as defined by the interval duration
                      above) to include this host in success rate based outlier detection.
                      If the volume is lower than this setting, outlier detection
                      via success rate statistics is not performed for that host.
                      Defaults to 100.
                    format: int64
                    minimum: 0
                    type: integer
                  successRateStdevFactor:
                    default: 1900
                    description: 'This factor is used to determine the ejection threshold
                      for success rate outlier ejection. The ejection threshold is
                      the difference between the mean success rate, and the product
                      of this factor and the standard deviation of the mean success
                      rate: mean - (stdev * successRateStdevFactor). This factor is
                      divided by a thousand to get a double. That is, if the desired
                      factor is 1.9, the runtime value should be 1900. Defaults to
                      1900.'
                    format: int64
                    minimum: 0
                    type: integer
                type: object
              targetRef:
                description: TargetRef identifies an API object to apply policy to.
                properties:
                  group:
                    description: Group is the group of the target resource.
                    maxLength: 253
                    pattern: ^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$
                    type: string
                  kind:
                    description: Kind is kind of the target resource.
                    maxLength: 63
                    minLength: 1
                    pattern: ^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$
                    type: string
                  name:
                    description: Name is the name of the target resource.
                    maxLength: 253
                    minLength: 1
                    type: string
                  namespace:
                    description: Namespace is the namespace of the referent. When
                      unspecified, the local namespace is inferred. Even when policy
                      targets a resource in a different namespace, it MUST only apply
                      to traffic originating from the same namespace as the policy.
                    maxLength: 63
                    minLength: 1
                    pattern: ^[a-z0-9]([-a-z0-9]*[a-z0-9])?$
                    type: string
                required:
                - group
                - kind
                - name
                type: object
            required:
            - targetRef
            type: object
          status:
            description: Status defines the current state of OutlierDetectionPolicy.
            properties:
              conditions:
                description: Conditions describe the current conditions of the OutlierDetectionPolicy.
                items:
                  description: "Condition contains details for one aspect of the current
                    state of this API Resource. --- This struct is intended for direct
                    use as an array at the field path .status.conditions.  For example,
                    type FooStatus struct{     // Represents the observations of a
                    foo's current state.     // Known .status.conditions.type are:
                    \"Available\", \"Progressing\", and \"Degraded\"     // +patchMergeKey=type
                    \    // +patchStrategy=merge     // +listType=map     // +listMapKey=type
                    \    Conditions []metav1.Condition `json:\"conditions,omitempty\"
                    patchStrategy:\"merge\" patchMergeKey:\"type\" protobuf:\"bytes,1,rep,name=conditions\"`
                    \n     // other fields }"
                  properties:
                    lastTransitionTime:
                      description: lastTransitionTime is the last time the condition
                        transitioned from one status to another. This should be when
                        the underlying condition changed.  If that is not known, then
                        using the time when the API field changed is acceptable.
                      format: date-time
                      type: string
                    message:
                      description: message is a human readable message indicating
                        details about the transition. This may be an empty string.
                      maxLength: 32768
                      type: string
                    observedGeneration:
                      description: observedGeneration represents the .metadata.generation
                        that the condition was set based upon. For instance, if .metadata.generation
                        is currently 12, but the .status.conditions[x].observedGeneration
                        is 9, the condition is out of date with respect to the current
                        state of the instance.
                      format: int64
                      minimum: 0
                      type: integer
                    reason:
                      description: reason contains a programmatic identifier indicating
                        the reason for the condition's last transition. Producers
                        of specific condition types may define expected values and
                        meanings for this field, and whether the values are considered
                        a guaranteed API. The value should be a CamelCase string.
                        This field may not be empty.
                      maxLength: 1024
                      minLength: 1
                      pattern: ^[A-Za-z]([A-Za-z0-9_,:]*[A-Za-z0-9_])?$
                      type: string
                    status:
                      description: status of the condition, one of True, False, Unknown.
                      enum:
                      - "True"
                      - "False"
                      - Unknown
                      type: string
                    type:
                      description: type of condition in CamelCase or in foo.example.com/CamelCase.
                        --- Many .condition.type values are consistent across resources
                        like Available, but because arbitrary conditions can be useful
                        (see .node.status.conditions), the ability to deconflict is
                        important. The regex it matches is (dns1123SubdomainFmt/)?(qualifiedNameFmt)
                      maxLength: 316
                      pattern: ^([a-z0-9]([-a-z0-9]*[a-z0-9])?(\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*/)?(([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9])$
                      type: string
                  required:
                  - lastTransitionTime
                  - message
                  - reason
                  - status
                  - type
                  type: object
                maxItems: 8
                type: array
                x-kubernetes-list-map-keys:
                - type
                x-kubernetes-list-type: map
            type: object
        required:
        - spec
        type: object
    served: true
    storage: true
    subresources:
      status: {}
status:
  acceptedNames:
    kind: ""
    plural: ""
  conditions: []
  storedVersions: []
